# -*- coding: utf-8 -*-
"""
Created on Mon May  6 10:05:12 2019

@author: Kristoffer Prestvold
"""


'''
I denne modellen er det modellert inn én ekstra tank, ellers kan den kjøres som "Modellen.py"
'''



#%%
import numpy as np
import matplotlib.pyplot as plt
import pandas as pd
plt.close('all')

#Velger pådrag på pumpe JP0001, Valg A
m_vek=1.15

# Velger størrelse på varmeveksler
A=14.3   # Dimensjonerende: 145 kW, Valg B
dA=0.3

#A=24.14 #Effekt på 245 kW
#dA=0.6

'''
Leser inn data fra målinger:
    
Datalogger 3 er målinger fra XX til XX og ble brukt til validering av modellen, 
og til å simulere forbedringsmuligheter

Datalogger 4 er målinger fra XX til XX som viser hvordan kretsen presterte etter pådraget
på pumpen ble endret.
Begge filene ble benyttet for å se hvordan endelig reguleringsforslag til pumpen fungerte.

"forste" og "siste" velger hvilke rader som skal lastes inn fra den valgte Datalogger.csv filen
og dermed hvilke tidspunkt modellen skal simulere

For "Datalogger3.csv":
    forste= 2, siste= 10022, 1 uke fra mandag  00:00 til søndag 23:59


For "Datalogger4.csv":
10.04 kl. 08:00 (pumpebytte kl. 00733) tilsvarer rad 3362
søndag 14.04 kl. 23:59 tilsvarer rad 10081
'''


df=pd.read_csv('Datalogger3.csv') # Leser inn csv fil, Valg C
#Velger fra/ til rad, Valg D
forste= 2
siste=10022


tid=60
volum=500


'''
Definerer funksjoner 

Forklaring av disse finnes i delkapittel X.X
'''

#Funksjon for oppfylling av tanker
def fylle_tank(m_tur,T_uv,T_tank,T_blanding):
  
    bet=0
    m_ut=m_tur
    m_jurg=0
    
    while bet==0:
        
        m_fylling=m_vek-m_ut
        prosent= (m_fylling*tid)/volum
    

        T_tur=T_uv
        T_tank[9]=T_tank[9]*(1-prosent)+T_tank[8]*prosent
        T_tank[8]=T_tank[8]*(1-prosent)+T_tank[7]*prosent
        T_tank[7]=T_tank[7]*(1-prosent)+T_tank[6]*prosent
        T_tank[6]=T_tank[6]*(1-prosent)+T_tank[5]*prosent
        T_tank[5]=T_tank[5]*(1-prosent)+T_tank[4]*prosent
        T_tank[4]=T_tank[4]*(1-prosent)+T_tank[3]*prosent
        T_tank[3]=T_tank[3]*(1-prosent)+T_tank[2]*prosent
        T_tank[2]=T_tank[2]*(1-prosent)+T_tank[1]*prosent
        T_tank[1]=T_tank[1]*(1-prosent)+T_tank[0]*prosent
        T_tank[0]=T_tank[0]*(1-prosent)+T_uv*prosent
        
        if m_jurg>0:
            bet=1
            T_tur=(m_ut*T_tur + m_jurg*T_blanding)/m_tur
        elif T_tur<62: #58.2
            bet=1
        elif T_tur>62: #  58.2 Endre denne til 62 om jurg ikke skal være i bruk
            m_jurg=(m_tur*(58-T_tur))/(T_blanding-T_tur)
            m_ut=m_tur-m_jurg
            if m_jurg<0.001:
                m_jurg=0
                bet=1
        
        
    return T_tank,T_tur,m_jurg, m_fylling
        

#Funksjon for tapping av tanker
def tomme_tank(m_tur,T_uv,T_blanding,T_tank):
    bet=0
    m_jurg=0
    m_tomme=m_tur-m_vek
    
    while bet==0:
        
        pros_tomme=(m_tomme*tid)/volum
    
        T_tank[0]=pros_tomme*T_tank[1] + (1-pros_tomme)*T_tank[0]
        T_tank[1]=pros_tomme*T_tank[2] + (1-pros_tomme)*T_tank[1]
        T_tank[2]=pros_tomme*T_tank[3] + (1-pros_tomme)*T_tank[2]
        T_tank[3]=pros_tomme*T_tank[4] + (1-pros_tomme)*T_tank[3]
        T_tank[4]=pros_tomme*T_tank[5] + (1-pros_tomme)*T_tank[4]
        T_tank[5]=pros_tomme*T_tank[6] + (1-pros_tomme)*T_tank[5]
        T_tank[6]=pros_tomme*T_tank[7] + (1-pros_tomme)*T_tank[6]
        T_tank[7]=pros_tomme*T_tank[8] + (1-pros_tomme)*T_tank[7]
        T_tank[8]=pros_tomme*T_tank[9] + (1-pros_tomme)*T_tank[8]
        T_tank[9]=pros_tomme*T_blanding + (1-pros_tomme)*T_tank[9]
    
        T_tur=(T_uv*m_vek+T_tank[0]*m_tomme)/(m_vek+m_tomme)
    
        if m_jurg>0:
            bet=1
            T_tur=(m_tomme*T_tur + m_jurg*T_blanding)/(m_tomme+m_jurg)
        elif T_tur<62: #58.2
            bet=1
        elif T_tur>62: #  58.2 Endre denne til 62 om jurg ikke skal være i bruk
            m_jurg=(m_tur*(58-T_tur))/(T_blanding-T_tur)
            m_tomme=m_tur-m_jurg
    
    return T_tank, T_tur, m_jurg

def inn_paa_veksler(T_blanding,m_tur,T_tank, m_fylling,m_blanding):
    m_blanding=m_vek-m_fylling 
    if m_vek > m_fylling:
        T_iv=(T_tank[9]*m_fylling+m_blanding*T_blanding)/m_vek
    else:
        T_iv=T_blanding
    return T_iv

def retur_blanding(T_kv,m_kv,T_sirk,m_sirk):
    return (T_kv*m_kv+T_sirk*m_sirk)/(m_kv+m_sirk)

def sirk_temp(T_tur):
    return 0.679*T_tur +13.42 # Denne er beregnet med verdier fra "Datalogger3.csv"

def veksler(T_iv,m_prim):
    
    differanse =1
    betingelse = 0
    while betingelse ==0:
        T_gjett=57
        endring=0
        while abs(differanse)>0.5:
            T_a=T_gjett
            U=2.03 
            #dA=0.6
            n=A/dA
            m_sek=m_vek
    
            #Preallokerer
            T_sek= np.ones((int(n+1),1))
            T_prim=np.ones((int(n+1),1))
            Q=np.ones((int(n),1))
            dT=np.ones((int(n),1))
    
            #Initierer
            T_prim[0]=60.13
            T_sek[0]=T_a
    
            for i in range(int(n)):
                dT[i]=T_prim[i]-T_sek[i]    
                Q[i]=U*dA*dT[i]
                T_prim[i+1]=T_prim[i]-Q[i]/(m_prim*4.2)
                T_sek[i+1]=T_sek[i]-Q[i]/(m_sek*4.2)  
                #return T_sek[i+1],T_prim[i+1]
            T_beregnet=T_sek[i+1]
            differanse=T_iv-T_beregnet
            if differanse >0.5:
                endring=2
            elif differanse < -0.5 and m_vek < 1:
                endring =-0.1
            elif differanse < -0.5 and m_vek > 1:
                endring =-1.7
            T_gjett+=endring/8
            if T_gjett > 60:
                T_gjett =60.1
            
        # Settpunkt på turtemperatur kan velges ved å sette T_a større eller miindre enn ønsket verdi
        if T_a > 57.8 and T_a < 58.2:
            betingelse=1
        elif T_a > 58.2:
             m_prim-=0.01 # disse to kommenteres ut om man ikke ønsker regulering av flow på primærside 
             differanse=1
                         
            #betingelse=1 #f
        elif T_a< 57.8 and m_prim < 1.15:
            m_prim+=0.01 #disse to kommenteres ut om man ikke ønsker regulering av flow på primærside
            differanse=1
            
            #betingelse= 1 #f
        elif T_a < 57.8 and m_prim >=1.15:
            betingelse =1
            
    
    return T_a,m_prim,T_prim[i+1]
"""


"""


#Målinger gjort med Schneider
m_tur=df['m_b'].values[forste-2:siste-1]
m_kv=df['m_kv'].values[forste-2:siste-1]
m_sirk=df['m_sirk'].values[forste-2:siste-1]
T_uvm=df['T_uvm'].values[forste-2:siste-1]
T_turm=df['T_turm'].values[forste-2:siste-1]
T_sirkm=df['T_sirkm'].values[forste-2:siste-1]
T_ivm=df['T_ivm'].values[forste-2:siste-1]
T_kv=df['T_kv'].values[forste-2:siste-1]



# Korrigering av massestrøm forklart i delkapittel X.X
# Denne delen kommenteres ut for å produsere figur XX


teller=0
i=0
vektor=np.ones((5,1))
for m in m_kv:
    vektor[teller]=m
    if teller == 4:
        m_kv[i-4:i+1]=np.mean(vektor)
        teller =-1
    i+=1
    teller+=1



#Fra datalogger
T2_m=df['Tank2'].values[forste-2:siste-1]
T2_m+=2
T4_m=df['Tank4'].values[forste-2:siste-1]
T4_m+=2
T6_m=df['Tank6'].values[forste-2:siste-1]
T6_m+=2
Prim_turm=df['Prim_tur'].values[forste-2:siste-1]
Prim_returm=df['Prim_retur'].values[forste-2:siste-1]
#T_jurgm=df['Jurg'].values[forste-2:siste-1]
T_blandingm=df['T_blandingm'].values[forste-2:siste-1]
T_blandingm+=2


'''
Preallokerer vektorer og matriser til beregning av temperaturer
'''

n=len(m_tur)
T_tank= np.ones((n,10)) #Matrise for temperatur i tankene
T_iv=np.ones((n,1)) #Preallokerer matrise for Temperatur inn på veksler
T_uv=np.ones((n,1)) # Preallokerer matrise for temperatur ut fra veksler
T_tur=np.ones((n,1))
T_sirk=np.ones((n,1))
T_blanding=np.ones((n,1))
Prim_retur=np.ones((n,1))
m_prim=np.ones((n,1))
m_jurg=np.zeros((n,1))
m_fylling=np.zeros((n,1))
m_blanding=np.zeros((n,1))
T_jurg=np.zeros((n,1))

T2=np.ones((n,1))
T4=np.ones((n,1))
T6=np.ones((n,1))
T8=np.ones((n,1))
T0=np.ones((n,1))


#Her kan man velge å endre vannmengden på sikrulasjonen
#sirk=0.2
#print('m_sirk= ',sirk)
#m_sirk=np.ones((n,1))*sirk

'''
Setter initialverdier til å være målte verdier for ønsket tidspunkt
'''

#Initialverdier

T_iv[0]= T_ivm[0] #
T_uv[0]=58 #
T_sirk[0]=T_sirkm[0]
T_tur[0]=58

#Velger om man vil initiere temperaturer i tankene fra målinger eller bestemme disse selv

#T_tank[0,0:4]=T2_m[0]
#T_tank[0,4:6]=T4_m[0]
#T_tank[0,6:9]=T6_m[0]
T_tank[0]=np.ones((1,10))*58 #Bestemmer at temperaturen i alle tankene er 58 grader


T_blanding[0]= T_blandingm[0]
Prim_retur[0]=Prim_returm[0]
m_prim[0]=1.15
m_jurg[0]=0
T_jurg[0]=0
m_blanding[0]=m_kv[0]+m_sirk[0]
m_fylling[0]=1.75

'''

Beregning av temperaturer i kretsen i det ønskede tidsrommet
ved å bruke tidligere definerte funksjoner

'''

for i in range(1,n):
    
    #T_sirk[i]=T_sirkm[i]
    T_sirk[i]=sirk_temp(T_tur[i-1]) # Ved simuleringer med annet pådrag enn som målt, brukes denne
    T_blanding[i]= retur_blanding(T_kv[i],m_kv[i],T_sirk[i],m_sirk[i])
    m_blanding[i]=m_kv[i]+m_sirk[i]
    m_tur[i]=m_blanding[i]
   
    
    
    T_iv[i]=inn_paa_veksler(T_blanding[i],m_tur[i],T_tank[i-1],m_fylling[i-1],m_blanding[i])      
    T_uv[i], m_prim[i], Prim_retur[i] = veksler(T_iv[i],m_prim[i-1])
    
    if m_vek > m_tur[i]:           
       T_tank[i],T_tur[i],m_jurg[i],m_fylling[i] =fylle_tank(m_tur[i],T_uv[i],T_tank[i-1],T_blanding[i])
       
       if m_jurg[i] >0:
           T_jurg[i]=T_blanding[i]
           m_blanding[i+1]=m_sirk[i]+m_kv[i]-m_jurg[i]
    else:                      
        T_tank[i],T_tur[i], m_jurg[i]=tomme_tank(m_tur[i],T_uv[i],T_blanding[i],T_tank[i-1])
        
        if m_jurg[i]>0:
            T_jurg[i]=T_blanding[i]
            m_blanding[i]=m_sirk[i]+m_kv[i]-m_jurg[i]
    
    

# Henter temperaturer fra T_tank, og plasserer de i vektorer for hver tank
teller=0
for i in range(n):
    T0[teller]=T_tank[i,0]
    T2[teller]=T_tank[i,2]
    T4[teller]=T_tank[i,4]
    T6[teller]=T_tank[i,6]
    T8[teller]=T_tank[i,8]
    teller+=1

'''
Plotting av beregnede temperaturer opp mot målte temperaturer
'''
#%%

T_uvm=np.transpose(np.matrix(T_uvm))
plt.figure()
plt.plot(range(n),T_uvm,label='Målinger')
plt.plot(range(n),T_uv,'r',label='Modell')
plt.legend()
plt.title('Ut fra veksler',fontweight='bold')
plt.show()


T_turm=np.transpose(np.matrix(T_turm))
plt.figure()
plt.plot(range(n),T_turm,label='Måling', linewidth=0.5)
#plt.plot(range(n),T_tur,'r',label='Simulering med dimensjonerende pådrag', linewidth=0.6)
plt.plot(range(n),T_tur,'r',label='Simulering', linewidth=0.6)
#plt.plot(range(n),T_tur,'r',label='Simulering med større veksler', linewidth=0.5)
plt.legend()
#plt.axis([0,n,50,60])
plt.title('Turtemperatur',fontweight='bold')
plt.ylabel('Temperatur [\xb0C]')
plt.xticks([720,2160,3600,5040,6480,7920,9360],['man.','tirs.','ons.','tors.','fred.','lør.','søn.'])
plt.show()

plt.figure()

T_sirkm=np.transpose(np.matrix(T_sirkm))
plt.plot(range(n),T_sirkm,label='Målinger')
plt.plot(range(n),T_sirk,'r',label='Modell')
plt.legend()
plt.title('Sirkulasjon',fontweight='bold')
plt.show()


T_blandingm=np.transpose(np.matrix(T_blandingm))
plt.figure()
plt.plot(range(n),T_blandingm,label='Målinger')
plt.plot(range(n),T_blanding,'r',label='Modell')
plt.legend()
plt.title('Blanddingstempereatur',fontweight='bold')
plt.show()


T_ivm=np.transpose(np.matrix(T_ivm))
plt.figure()
plt.plot(range(n),T_ivm,label='Målinger')
plt.plot(range(n),T_iv,'r',label='Modell')
plt.legend()
plt.title('Inn på veksler',fontweight='bold')
plt.show()



diff_Tuv=T_uvm-T_uv
diff_Turm=T_turm-T_tur
#diff_Tsirk=T_sirkm-T_sirk
diff_Tiv=T_ivm-T_iv
diff_Tblanding=T_blandingm-T_blanding

diff2=T2_m-T2
diff4=T4_m-T4
diff6=T6_m-T6


print('Standardavvik T_uv = %.2f '% np.std(diff_Tuv))
print('Standardavvik T_tur = %.2f '% np.std(diff_Turm))
#print('Standardavvik T_sirk = %.2f '% np.std(diff_Tsirk))
print('Standardavvik T_ipv = %.2f '% np.std(diff_Tiv))
print('Standardavvik Te = %.2f \n'% np.std(diff_Tblanding))

print('Standardavvik T2 = %.2f '% np.std(diff2))
print('Standardavvik T4 = %.2f '% np.std(diff4))
print('Standardavvik T6 = %.2f '% np.std(diff6))

plt.figure()
plt.plot(range(n),T2, 'r', label='Modell')
plt.plot(range(n), T2_m, label='Måling')
plt.show()
plt.title('Tank 2', fontweight='bold')
plt.xticks([720,2160,3600,5040,6480,7920,9360],['man.','tirs.','ons.','tors.','fred','lør','søn.'])
#plt.xlabel('Tid [min]')
plt.ylabel('Temperatur [\xb0C]')
plt.legend()

plt.figure()
plt.plot(range(n),T4, 'r', label='Modell')
plt.plot(range(n), T4_m, label='Måling')
plt.xticks([720,2160,3600,5040,6480,7920,9360],['man.','tirs.','ons.','tors.','fred','lør','søn.'])
plt.show()
plt.title('Tank 4a', fontweight='bold')
plt.legend()

plt.figure()
plt.plot(range(n),T6, 'r', label='Modell')
plt.plot(range(n), T6_m, label='Måling')
plt.xticks([720,2160,3600,5040,6480,7920,9360],['man.','tirs.','ons.','tors.','fred','lør','søn.'])
plt.show()
plt.title('Tank 4', fontweight='bold')
plt.ylabel('Temperatur [\xb0C]')
plt.legend()

plt.figure()
plt.plot(range(n),T0, 'r', label='Modell')
plt.show()
plt.title('Tank 0', fontweight='bold')
plt.legend()

plt.figure()
plt.plot(range(n),m_kv, 'r', label='Modell')
plt.show()
plt.title('m_kv', fontweight='bold')
plt.legend()

plt.figure()
plt.plot(range(n),T_iv, 'r', label='Modell')
plt.show()
plt.title('Temperatur inn på veksler', fontweight='bold')
plt.legend()
#%%
'''
grid=np.ones((100,500))*-10
bk=80

#%%
def farge(tank,T_sirk,T_blanding,T_ipv,T_a,Prim_retur,m_jurg,T_tur):
    bk=90
# Horisontale streker i tanker
    for i in range(150,271,40):
        for j in [30,70]:
            grid[j,i:i+20]=bk


#Vertikale streker for tanker
    for i in range(150,291,20):
        for j in range(30,71):
            grid[j,i]=bk
            
    #Ut av tank 1
    for j in [35,40]:
        grid[j,290:310]=bk
    for j in range(36,40):
        if m_jurg > 0:
            grid[j,290:311]=T_a
            grid[j,311:335]=T_tur
        else:
            grid[j,290:335]=T_tur
            
    
    # mot Jrgumatventil
    grid[35,310:335]=bk
    grid[40,315:335]=bk
    for j in range(40,82):
        grid[j,310]=bk
        grid[j,315]=bk
    for j in range(40,82):
        if m_jurg>0:
            grid[j,311:315]=T_blanding
        else:
            grid[j,311:15]=25 # ca romtemp
            
    
    teller=0    
    for i in [271,231,191,151]:      
        for j in range(31,51):
            grid[j,i:i+19]=tank[teller]
        teller+=1
        for j in range(51,70):
            grid[j,i:i+19]=tank[teller]
        teller+=1
        
        
    #Ut av tank 8
    for j in range(70,80):
        for i in [150,155]:
            grid[j,i]=bk
    for j in range(70,81):
        grid[j,151:155]=tank[7]
        
    
    
    
    #Streker for blanding av kaldvann og sirkulasjon
    for i in [400,405]:
        for j in range(60,80):
            grid[j,i]=bk
    grid[80,155:310]=bk
    grid[80,315:401]=bk
    grid[80,105:151]=bk
    grid[80,405:430]=bk
    grid[85,100:430]=bk
    
    #kaldtvann
    for j in range(81,85):
        grid[j,405:430]=5
    #Sirkulasjon
    for j in range(60,81):
        grid[j,401:405]=T_sirk
    #Blanding
    for j in range(81,85):
        grid[j,155:405]=T_blanding
        
    #Inn på veksler
    for j in range(65,85):
        grid[j,100]=bk
        grid[j,88]=bk
    for j in range(65,80):
        grid[j,105]=bk
        grid[j,83]=bk
    for j in range(81,85):
        grid[j,101:155]=T_ipv
    for j in range(65,81):
        grid[j,101:105]=T_ipv
        
    #Ut fra veksler
    grid[15,100:290]=bk
    grid[20,105:285]=bk
    for j in range(15,35):
        grid[j,100]=bk
        grid[j,88]=bk
    for j in range(20,35):
        grid[j,105]=bk
        grid[j,83]=bk
    for j in range(15,30):
        grid[j,290]=bk
    for j in range(20,31):
        grid[j,285]=bk
    
    for j in range(16,20):
        grid[j,101:290]=T_a
    for j in range(20,31):
        grid[j,286:290]=T_a
    for j in range(20,35):
        grid[j,101:105]=T_a
    
    #veksler
    grid[35,80:110]=bk
    grid[65,80:110]=bk
    for j in range(35,66):
        grid[j,80]=bk
        grid[j,110]=bk
        
    # Primær inn på veksler
    grid[15,60:88]=bk
    grid[20,60:83]=bk
    for j in range(16,20):
        grid[j,60:88]=60
    for j in range(20,35):
        grid[j,84:88]=60
        
    # Primær ut av veksler
    grid[80,60:84]=bk
    grid[85,60:89]=bk
    for j in range(66,85):
        grid[j,84:88]=Prim_retur
    for j in range(81,85):
        grid[j,60:84]=Prim_retur
        
    #Svarte linjer mellom tankene, 4-3,3-2 osv
    grid[50,210:230]=bk
    grid[50,170:190]=bk
    grid[50,250:270]=bk
    
    
    return grid

#%%
tid=0
plt.figure()    
#for i in range(n-1):
for i in range(3600,3615):
    plt.clf()
    farge(T_tank[i],T_sirk[i],T_blanding[i],T_iv[i],T_uv[i],Prim_retur[i],m_jurg[i],T_tur[i])
    plt.imshow(grid,cmap='hot_r',vmin=20,vmax=bk  )
    plt.figtext(0.66,0.41,'%.1f\xb0 C' % T_blanding[i] ,fontsize='small') # Blandingstemp
    plt.figtext(0.735,0.48,'%.1f\xb0 C'% T_sirk[i],fontsize='small') #Sirkulasjonstemp
    plt.figtext(0.375,0.41,'%.1f\xb0 C'% T_tank[i,7],fontsize='small') # Ut av tank 4
    plt.figtext(0.3,0.41,'%.1f\xb0 C'% T_iv[i],fontsize='small') #Inn på veksler
    plt.figtext(0.3,0.615,'%.1f\xb0 C'% T_uv[i], fontsize='small') #Ut fra veksler
    plt.figtext(0.62,0.55,'%.1f\xb0 C'% T_tur[i], fontsize='small') # Turtemperatur
    plt.figtext(0.185,0.39,'%.1f\xb0 C'% Prim_retur[i], fontsize='small') # Returtemp fjernvarme
    #plt.figtext(0.22,0.41,'%1.f\xb0 C' % 45 , fontsize='small') # Primærside retur
    #plt.figtext(0.22,0.615,'%1.f\xb0 C' % 60, fontsize='small') # Primærside tur
    plt.figtext(0.395,0.505,'%.1f\xb0 C'% T6[i], fontsize='small') # 5-6
    plt.figtext(0.455,0.505,'%.1f\xb0 C'% T4[i], fontsize='small') # 3-4
    plt.figtext(0.52,0.505,'%.1f\xb0 C'% T2[i], fontsize='small') # 3-4
    plt.figtext(0.72,0.51,'Sirkulasjon',fontweight='bold')
    plt.figtext(0.8,0.39, 'Kaldtvann',fontweight='bold')
    plt.figtext(0.26,0.51,'Varme-',fontweight='bold')
    plt.figtext(0.26,0.48,'veksler',fontweight='bold')
    plt.figtext(0.65,0.53,'Tur',fontweight='bold')
    plt.figtext(0.53,0.565,'Tank 1',fontweight='bold')
    plt.figtext(0.485,0.565,'Tank 2',fontweight='bold')
    plt.figtext(0.42,0.565,'Tank 3',fontweight='bold')
    plt.figtext(0.36,0.565,'Tank 4',fontweight='bold')
    plt.title('Temperaturer etter %d minutter' % tid)
    plt.axis('off')
    plt.draw()
    plt.pause(0.6)
    plt.grid(b=0)
    tid+=1


#%%
'''
#%%
plt.figure()
plt.plot(range(n),T0, label='Tank 1')
plt.plot(range(n),T2, label='Tank 2')
plt.plot(range(n),T4, label='Tank 3')
plt.plot(range(n),T6, label='Tank 4')
plt.plot(range(n),T8, label='Tank 5')



#plt.plot(range(n),T_tur,'r', label='Turtemperatur')
plt.legend()
#plt.title('Pådrag pumpe = %.2f l/s, Effekt varmeveksler = %d kW' % (m_a,veksler), fontweight='bold')
plt.title('Temperaturendring i varmtvannstanker',fontweight='bold')
plt.ylabel('Temperatur [\xb0C]')
plt.xticks([720,2160,3600,5040,6480,7920,9360],['man.','tirs.','ons.','tors.','fred','lør.','søn.'])

plt.figure()
plt.plot(range(n),T_tur,'r', linewidth=0.6,label='Simulering')
plt.title('Turtemperatur',fontweight='bold')
plt.ylabel('Temperatur [\xb0C]')
plt.xticks([720,2160,3600,5040,6480,7920,9360],['man.','tirs.','ons.','tors.','fred.','lør.','søn.'])
plt.axis([0,n,50,60])


print('m_kv mandag = ', np.sum(m_kv[0:1440]))
print('m_kv tirsdag = ', np.sum(m_kv[1440:2880]))
print('m_kv onsdag = ', np.sum(m_kv[2880:4320]))
print('m_kv torsdag = ', np.sum(m_kv[4320:5760]))
print('m_kv fredag = ', np.sum(m_kv[5760:7200]))
print('m_kv lørdag = ', np.sum(m_kv[7200:8640]))
print('m_kv søndag = ', np.sum(m_kv[8640:10040]))


plt.figure()
plt.plot(range(n),Prim_returm, linewidth=0.6, label='Måling')
plt.plot(range(n),Prim_retur,'r',linewidth=0.6, label='Simulering')
plt.xticks([720,2160,3600,5040,6480,7920,9360],['man.','tirs.','ons.','tors.','fred','lør'])
plt.ylabel('Temperatur [\xb0C]')
plt.title('Retur fjernvarme',fontweight='bold')
plt.legend()

plt.figure()
plt.plot(range(n),m_prim)
plt.title('m_prim',fontweight='bold')

plt.figure()
plt.plot(range(n),m_jurg)
plt.title('m_jurg', fontweight='bold')

print('Gjennomsnittlig returtemperatur simulering = %.2f, måling= %.2f' % (np.mean(Prim_retur),np.mean(Prim_returm)))

#%%
plt.figure()
plt.plot(range(100),T_tur[0:100],'r', label='Simulering',linewidth=0.6)
plt.plot(range(100),T_turm[0:100], label='Måling',linewidth=0.5)
plt.axis([0,100,54,59])
plt.xlabel('Minutter')
plt.ylabel('Temperatur [\xb0C]')
plt.title('Turtemperatur',fontweight='bold')
plt.legend()

'''
Nøkkeltall for simuleringen
'''
print('Nøkkeltall fra simuleringen:')
print('Gjennomsnittlig simulert turtemperatur = %.2f \xb0C' % np.mean(T_tur))
print('Minste turtemperatur = %.2f \xb0C' % np.min(T_tur))
print('Antall simulerte turtemperaturer under 54 \xb0C = %.0f' % len(np.argwhere(T_tur<54)))
print('Kaldeste temperatur i øvre del av Tank 1 = %.2f \xb0C' % np.min(T0))
print('Gjennomsnittlig returtemperatur primærside = %.2f \xb0C' % np.mean(Prim_retur))